;------------------------------------------------------------
;    Quick Delete boards (C) KIV without Co
;    -   ࠧ ⥫  ᥬ ;)
;------------------------------------------------------------
;
;    ணࠬ  㤠  (஬ ࠢ! ;) ᥬ
;     । board' Hudson Message Base
;    : Qdel  path_to_QBBS  board board ...
;
;    board - ᫮  1  200
;     * -  board'
;     ᫮-  -  㤠  ⮣
;
;     祥 - ⨯ *-  ⠬ 45-12 -  ਢ  
;    ᪮쪮  १⠬!  ⥫쭮 
;    ९뢠 ணࠬ ᠬ!
;
;     ⮫쪮 ⠢ ᮮ⢥饣 ,  ⮬
;    ᫥ 㤠 ᫥    ଠ 騪 ;)
;
;-------------------------------------------------------------
;
;         2:463/59, 2:463/59.1
;
;-------------------------------------------------------------

code	segment byte public 'CODE'
	assume  cs:code, ds:code
	org 100h

MS	EQU	[bp]

; - ,   ;) -  ⮡  ⥪  ;))
QNT	EQU	100
	
MSG	STRUC
	msgNum		dw	?
	prev		dw	?
	next		dw	?
	timesRead	dw	?
	startBlock	dw	?
	numBlocks	dw	?
	destNet		dw	?
	destNode	dw	?
	origNet		dw	?
	origNode	dw	?
	destZone	db	?
	origZone	db	?
	cost		dw	?
	msgAttr		db	?
	netAttr		db	?
	board		db	?
	other		db	160 dup(?)
ENDS

TBL	EQU	[bp][QNT*(SIZE MSG)+1]


PRINT	MACRO	str
	lea	dx,str
	mov	ah,9
	int	21h
ENDM	PRINT


start:
	;   ⥪   ⠡  201  
	;   QNT ⮢ MSGHDR.BBS
	sub	sp,203+QNT*(SIZE MSG)
	;   ﬨ
	mov	bp,sp
	mov	di,sp
	cld
	xor	ax,ax
	mov	cx, (203+ QNT*(SIZE MSG))/2
	rep	stosw
	
	; 뢮 Copyright
	PRINT	Copyright
	
	; 稭 ࠧ  ப
	mov	di,80h
	cmp	byte ptr ds:[di],0
	je	NoCommandLine
	
	; 饬  ஡
	inc	di
	xor	cx,cx
	mov	cl,ds:[80h]
	mov	al,' '
	repe	scasb
	jcxz	NoCommandLine
	; ࠭塞 祭 砫 ࢮ ࠬ
	mov	Directory,di
	dec	Directory
	
	;  ⥯ 饬 ன  稥 ࠬ...
	repne	scasb
	jcxz	NoCommandLine
	; ࠭塞  ஡ ᫥ ࢮ ࠬ
	mov	DirectoryEnd,di
	
	; , ࠧ 諨 -   ...


	mov	si,di
	jmp	EndString
ScanSpace:
	inc	si
IsSpace:
	cmp	byte ptr [si],32
	je	ScanSpace
	cmp	byte ptr [si],9
	je	ScanSpace
	xor	cx,cx
	jmp	IsDigit
CalcParam:
	cmp	cx,200
	ja	Above200
	mov	al,byte ptr [si]
	cbw	
	push	ax
	mov	ax,cx
	mov	dx,10
	imul	dx
	pop	dx
	add	ax,dx
	sub	ax,48
	mov	cx,ax
Above200:
	inc	si
IsDigit:
	cmp	byte ptr [si],'*'
	je	DelStar
	cmp	byte ptr [si],48
	jl	NonDigit
	cmp	byte ptr [si],57
	jle	CalcParam
NonDigit:
	or	cx,cx
	jbe	NoRange
	cmp	cx,200
	ja	NoRange
	mov	di,cx
	cmp	byte ptr [si],'-'
	je	resetTBL
	mov	byte ptr TBL[di],1
	jmp	NoRange
resetTBL:
        inc	si
	mov	byte ptr TBL[di],0
	
NoRange:
	cmp	byte ptr [si],32
	je	EndString
	cmp	byte ptr [si],13
	je	EndString
	cmp	byte ptr [si],9
	jne	InvalidParam
EndString:
	cmp	byte ptr [si],13
	jne	IsSpace
	
	jmp	CheckFile

delStar:
        push	cx
        mov	cx,200
LoopStar:
	mov	di,cx
	mov	byte ptr TBL[di],1
	loop	LoopStar
	pop	cx
	inc	si
	jmp	NonDigit       	
	
	
InvalidParam:
	PRINT	ErrorParamMsg
	PRINT	NoCommandLineMsg
	jmp	Quit
	
	
CheckFile:	
	mov	di,DirectoryEnd
	dec	di
	dec	di
	cmp	byte ptr [di],':'
	je	NoSlash
	cmp	byte ptr [di],'\'
	je	NoSlash
	inc	di
	mov	byte ptr [di],'\'
NoSlash:
	inc	di
	lea	si,HdrName
	mov	cx,11
	cld
	rep	movsb
	dec	di
	mov	DirectoryEnd,di
	
	; ஡㥬  䠩
	mov	dx,Directory
	mov	ax,3DC2h
	int	21h
	jc	CanNotOpen
	mov	Handle,ax
	; 稭 议 横 ⥭/஢ન/...


ReadLoop:	
	mov	al,CharLoop
	inc	al
	cmp	al,4
	jne	WriteChar
	mov	al,0
WriteChar:
	mov	CharLoop,al
	mov	ah,0
	lea	di,Chars
	add	di,ax
	mov	dl,[di]
	mov	ah,2
	int	21h
	mov	dl,8
	mov	ah,2
	int	21h
	
	
	mov	dx,bp
	mov	bx,Handle
	mov	cx,QNT*(SIZE MSG)
	mov	ah,3Fh
	int	21h
	mov	Records,ax
	or	ax,ax
	jz	AllDone
	xor	dx,dx
	mov	cx, SIZE MSG
	div	cx
	mov	cx,ax		; - ⠭ ᥩ
	add	AllCount,ax
	mov	byte ptr RewriteNeed,0
	mov	si,bp
	sub	si,SIZE MSG
CheckData:
	add	si,SIZE MSG
	test	(MSG ptr [si]).msgAttr,1
	jnz	AlreadyDel
	test	(MSG ptr [si]).msgAttr,22h
	jnz	NoDelete			;This message not send yet!
	mov	bh,0
	mov	bl, (MSG ptr [si]).board
	mov	di,bx
	cmp	byte ptr TBL[di],0
	je	NoDelete
	mov	byte ptr RewriteNeed,1
	or	(MSG ptr [si]).msgAttr,1
	inc	DelCount
	jmp	NoDelete
AlreadyDel:
	inc	AlrDel
NoDelete:
	loop	CheckData
	cmp	byte ptr RewriteNeed,0
	je	NoWrite
	mov	bx,Handle
	mov	ax,Records
	xor	dx,dx
	neg	dx
	neg	ax
	sbb	dx,0
	mov	cx,dx
	mov	dx,ax
	mov	ax,4201h
	int	21h
	mov	dx,bp
	mov	cx,Records
	mov	ah,40h
	int	21h
NoWrite:
	cmp	word ptr Records, (SIZE MSG)*QNT
	jne	AllDone
	jmp	ReadLoop
AllDone:
	mov	bx,Handle
	mov	ah,3Eh
	int	21h
	PRINT	TotalMessages
	mov	ax,AllCount
	call	WRITE
	PRINT	EOL
	PRINT	AlreadyMessages
	mov	ax,AlrDel
	call	WRITE
	PRINT	EOL
	PRINT	DeletedMessages
	mov	ax,DelCount
	call	WRITE
	PRINT	EOL
	PRINT	InBoard
	xor	bx,bx
	mov	ah,0
	mov	cx,200
	lea	si,TBL[1]
Sum:
	lodsb
	add	bx,ax
	loop	Sum
	mov	ax,bx
	call	WRITE
	PRINT	EOL
	jmp	Quit
	
	

CanNotOpen:
	PRINT	ErrorOpenMsg
	mov	si,DirectoryEnd
	mov	word ptr ds:[si],0D0Ah
	inc	si
	inc	si
	mov	byte ptr [si],'$'
	mov	dx,Directory
	mov	ah,9
	int	21h
	jmp	Quit
	
NoCommandLine:
	PRINT	NoCommandLineMsg
Quit:
	mov	ax,4C00h
	int	21h


WRITE	proc	near
	lea	di,Number
	mov	word ptr [di],   2020h
	mov	word ptr [di+2], 2020h
	mov	byte ptr [di+4], 20h
	
	mov	bx,4
@@NextChar:
	xor	dx,dx
	mov	cx,10
	div	cx
	add	dx,'0'
	mov	byte ptr [di][bx],dl
	dec	bx
	cmp	ax,0
	jne	@@NextChar
	lea	dx,Number
	mov	ah,9
	int	21h
	ret
WRITE	endp



CharLoop	 db	0
Chars		 db	"|/-\"
RewriteNeed	 db	0
Handle		 dw	0
Records		 dw	0
AllCount	 dw	0	; ᥣ ᥬ
DelCount	 dw	0	; 㤠 
AlrDel		 dw	0	; 㦥 㤠
CurPos		 dd	0	
Directory	 dw	0
DirectoryEnd	 dw	0
ParamFlag	 db	0
HdrName		 db	"MSGHDR.BBS",0
ErrorOpenMsg	 db	"Can not open file $"
Copyright	 db "QDEL 1.3 (C) KIV without Co",13,10,'$'
NoCommandLineMsg db "Usage: QDEL <MSGBASE PATH> <board1> <board2>...",13,10,'$'
ErrorParamMsg	 db "Invalid parameter found",13,10,'$'
TotalMessages	 db "Total message(s)   $"
AlreadyMessages	 db "Already deleted    $"
DeletedMessages  db "Deleted messages   $"
InBoard		 db "Deleted board(s)   $"
EOL	 	 db 13,10,'$'
Number		 db "     $"

code	ENDS
	END	start
